local tabardlink = nil
local tabardchat = true
local version = GetAddOnMetadata("IhateTabards", "Version") 

local function print(msg)
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff78Ihatetabards:|r "..msg)
end

local function settabard()
	tabardlink = GetInventoryItemLink("player", GetInventorySlotInfo("TabardSlot"))
	IhateTabards_Tabard = tabardlink
end

-- equip taht ugly thing -.-
local function equiptabard()
	if tabardlink then
		EquipItemByName(tabardlink, GetInventorySlotInfo("TabardSlot"))
		if tabardchat then
			print("equipped "..tabardlink.." you are ugly now -.-")
		end
	end
end

-- retrun the id of an bag with a free slot
-- 0 if free slot InBackpack
-- nil if all bags are full
local function getFreeBag()
	for bagid = NUM_BAG_SLOTS, 0, -1 do
		if GetContainerNumFreeSlots(bagid) > 0 then
			return bagid
		end
	end
	return nil
end

-- and off with it, yeah!
local function removetabard()
	if tabardlink then
		ClearCursor()
		PickupInventoryItem(GetInventorySlotInfo("TabardSlot"))
		
		local freeid = getFreeBag()
		if freeid then
			if freeid == 0 then
				PutItemInBackpack()
			else
				PutItemInBag(freeid+19)
			end
			--unequip any tabard
			local currentequipped = GetInventoryItemLink("player", GetInventorySlotInfo("TabardSlot"))
			if currentequipped and tabardchat then
				print("relieved you of "..currentequipped.." yeah!")
			end
		else
			print("can't remove tabard, inventory is full *cry*")
			ClearCursor()
		end
	end
end

local function enteringWorld()
	if event == "PLAYER_ENTERING_WORLD" then
		local inini, initype = IsInInstance() 
		--print(initype)
		if initype == "party" then
			equiptabard()
		else
			removetabard()
		end
	else 
		tabardlink = IhateTabards_Tabard
		tabardchat = Ihatetabards_Chat
	end
end

local function slashHandler(msg)
	--set
	if msg == "set" then
		settabard()
	elseif msg == "clear" then
		tabardlink = nil
		IhateTabards_Tabard = nil
	elseif msg == "chat" then
		tabardchat = not tabardchat
		Ihatetabards_Chat = tabardchat
	else
		-- no comannd option
		print("Version "..version)
		print("Usage: /iht {set | clear}")
		print("- set: Auto equip/take off your currently equipped tabard.")
		print("- clear: Disable Ihatetabards.") 
		print("- chat: Toggle chat messages.")
	end
	
	if tabardchat then
		print("chat messages on.")
	else
		print("chat message off.")
	end
	if tabardlink then
		print("Currently set to: "..tabardlink)
	else
		print("no Tarbard set.")
	end
end

SlashCmdList["Ihatetabards"] = slashHandler;
SLASH_Ihatetabards1 = "/ihatetabards";
SLASH_Ihatetabards2 = "/iht";

local frame = CreateFrame("Frame")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("VARIABLES_LOADED")
frame:SetScript("OnEvent", enteringWorld)